<script setup lang="ts">
import { computed, onMounted, watch } from 'vue'
import { nextTick, ref } from 'vue'
import type { User } from '@/types/User'
import type { VForm } from 'vuetify/components'
import http from '@/services/http'
import { useLoadingStore } from '@/stores/loading'

import { usePromotionStore } from '@/stores/Promotion'
import promotion from '@/services/promotion'
import type { Promotion } from '@/types/Promotion'
import PromotionText from '@/components/PromotionComponent/PromotionText.vue'
import PromotionStartdatepicker from '@/components/PromotionComponent/PromotionStartdatepicker.vue'
import PromotionEnddatepicker from '@/components/PromotionComponent/PromotionEnddatepicker.vue'
import PromotionItemSelector from '@/components/PromotionComponent/PromotionItemSelector.vue'
import { useProductStore } from '@/stores/Product'

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Promotion Name',
    value: 'name',
    key: 'name'
  },
  {
    title: 'Promotion Code',
    value: 'code',
    key: 'code'
  },
  {
    title: 'Promotion Detail',
    key: 'detail'
  },
  {
    title: 'Start-Date',
    value: 'startdate',
    key: 'startdate'
  },
  {
    title: 'End-date',
    value: 'enddate',
    key: 'enddate'
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
  },
  { key: 'actions', sortable: false }
  // เอาไว้Log
  // { title: 'log ออกมาดู', key: 'log' }
]

const promotionStore = usePromotionStore()
const loadingStore = useLoadingStore()
const form = ref(false)
const loading = ref(false)
const dialog = ref(false)
const dialogDelete = ref(false)
const refForm = ref<VForm | null>(null)
const menu2 = ref(false)
const menu1 = ref(false)

let editedIndex = -1
let lastId = 5

function onSubmit() {}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    promotionStore.clearForm()
  })
}

async function deleteItemConfirm() {
  await promotionStore.delPromotion()
  closeDelete()
}

async function editItem(item: Promotion) {
  if (!item.id) return
  await promotionStore.getPromotion(item.id)
  dialog.value = true
}

// function deleteItem(item: User) {
//   editedIndex = users.value.indexOf(item)
//   editedUser.value = Object.assign({}, item)
//   dialogDelete.value = true
//   editedIndex = -1
// }
async function deleteItem(item: Promotion) {
  if (!item.id) return
  await promotionStore.getPromotion(item.id)
  dialogDelete.value = true
  editedIndex = -1
}

const productStore = useProductStore()
onMounted(() => {
  promotionStore.getPromotions()
  productStore.getProducts()
})
async function closeDialog() {
  dialog.value = false
  nextTick(async () => {
    await promotionStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await promotionStore.savePromotion()

  closeDialog()
}

// function searchUser(name: string) {
//   if (name.trim() === '') {
//     userStore.getUsers()
//     return
//   }

//   const foundUsers = users.value.filter((user) =>
//     user.name.toLowerCase().includes(name.toLowerCase())
//   )
//   users.value = foundUsers
// }

// const name = ref('')
// function onClick() {
//   searchUser(name.value)
// }

// เพื่อที่จะเช็คว่ามันnull ไหม
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="promotionStore.promotions" class="custom-datatable">
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgb(247, 156, 82)">
          <v-toolbar-title style="color: white; font-weight: bold; font-size: 30px"
            >Promotion</v-toolbar-title
          >
          <!-- <v-text-field
            v-model="name"
            density="compact"
            variant="solo"
            label="Search Name"
            append-inner-icon="mdi-magnify"
            single-line
            hide-details
            @click:append-inner="onClick"
            @keyup.enter="onClick()"
          ></v-text-field> -->

          <v-btn
            icon="mdi-cached"
            style="color: white"
            @click="promotionStore.getPromotions()"
          ></v-btn>
          <v-divider class="mx-4" inset vertical></v-divider>

          <v-spacer></v-spacer>

          <!-- Put Edited  Dialog -->
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                prepend-icon="mdi-plus"
                outlined
                v-bind="props"
                style="color: white; background-color: green"
              >
                New Promotion
              </v-btn>
            </template>
            <v-card color="white">
              <v-card-title>
                <span class="text-h5" style="font-weight: bold; color: rgb(247, 156, 82)"
                  >Promotion</span
                >
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="6">
                        <v-text-field
                          v-model="promotionStore.editedPromotion.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Promotion Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="6">
                        <v-text-field
                          label="Promotion Code"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          v-model="promotionStore.editedPromotion.code"
                        ></v-text-field
                      ></v-col>
                      <v-col cols="6">
                        <PromotionStartdatepicker></PromotionStartdatepicker>
                      </v-col>
                      <v-col cols="6"><PromotionEnddatepicker></PromotionEnddatepicker> </v-col>
                      <PromotionItemSelector></PromotionItemSelector>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*กรุณากรอกข้อมูลให้ครบถ้วน</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  color="white"
                  variant="elevated"
                  class="textcenter"
                  size="large"
                  @click="closeDialog()"
                >
                  Close
                </v-btn>
                <v-btn
                  color="#F79C52 "
                  variant="elevated"
                  class="textcenter"
                  size="large"
                  @click="save()"
                >
                  Save
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this Promotion?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.log`]="{ item }">
        {{ item }}
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="blue-accent-4" class="me-2" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="red-accent-4" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:[`item.detail`]="{ item }">
        <PromotionText :promotionItems="item.promotionItems"></PromotionText>
      </template>
      <template v-slot:no-data>
        <v-btn color="rgb(214, 175, 125)" @click="promotionStore.getPromotions()"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>

<style>
.custom-datatable th {
  background-color: rgb(236, 235, 235);
  color: black;
  font-weight: bold !important; 
  font-size: 15px; /* Adjust the font size as needed */
}
</style>
